// Generated by CoffeeScript 1.12.3
(function() {
  var DOMMutationNotifier, EventEmitter, nodeTypeNames;

  EventEmitter = require('events').EventEmitter;

  nodeTypeNames = {
    1: "element",
    2: "attribute",
    3: "text",
    8: "comment"
  };

  module.exports = DOMMutationNotifier = (function() {
    function DOMMutationNotifier(el, options) {
      var emitter, isRunning, listenerLists, name, number, observer, start, stop;
      if (options == null) {
        options = {};
      }
      if (options.childList == null) {
        options.childList = true;
      }
      if (!(el instanceof HTMLElement)) {
        throw new Error("Fist argument must be a HTMLElement.");
      }
      if (!(options.childList || options.attributes || options.characterData)) {
        throw new Error("Neither childList, attributes or characterData chosen.");
      }
      emitter = new EventEmitter;
      observer = new MutationObserver((function(_this) {
        return function(mutations) {
          var addedNode, i, j, k, len, len1, len2, mutation, ref, ref1, removedNode;
          for (i = 0, len = mutations.length; i < len; i++) {
            mutation = mutations[i];
            ref = mutation.addedNodes;
            for (j = 0, len1 = ref.length; j < len1; j++) {
              addedNode = ref[j];
              emitter.emit(nodeTypeNames[addedNode.nodeType] + "Added", addedNode);
            }
            ref1 = mutation.removedNodes;
            for (k = 0, len2 = ref1.length; k < len2; k++) {
              removedNode = ref1[k];
              emitter.emit(nodeTypeNames[removedNode.nodeType] + "Removed", removedNode);
            }
          }
          return void 0;
        };
      })(this));
      listenerLists = {};
      for (number in nodeTypeNames) {
        name = nodeTypeNames[number];
        listenerLists[name + "Added"] = [];
        listenerLists[name + "Removed"] = [];
      }
      isRunning = false;
      start = function() {
        observer.observe(el, options);
        return isRunning = true;
      };
      stop = function() {
        observer.disconnect();
        return isRunning = false;
      };
      this.on = function(eventName, listener) {
        if (!listenerLists[eventName]) {
          throw new Error("Invalid event name '" + eventName + "'");
        }
        listenerLists[eventName].push(listener);
        emitter.on(eventName, listener);
        if (!isRunning) {
          return start();
        }
      };
      this.off = function(eventName, listener) {
        var listenerList, listenerPosition, numListeners;
        if (!listenerLists[eventName]) {
          throw new Error("Invalid event name '" + eventName + "'");
        }
        listenerList = listenerLists[eventName];
        listenerPosition = listenerList.indexOf(listener);
        if (!(listenerPosition >= 0)) {
          throw new Error("Function was not a listener for '" + eventName + "'");
        }
        listenerList.splice(listenerPosition, 1);
        numListeners = 0;
        for (name in listenerLists) {
          listenerList = listenerLists[name];
          numListeners += listenerList.length;
        }
        if (isRunning && numListeners === 0) {
          return stop();
        }
      };
    }

    return DOMMutationNotifier;

  })();

}).call(this);

//# sourceMappingURL=dom-mutation-notifier.js.map
